<?php  
class language {  
	
	var $items = array();  
	var $languagepackid = 0; 
	var $path = '.';
	
	function language($languagepackid, $path = '.') {
		$this->languagepackid = $languagepackid;
		$this->path = $path;
	}
	
	function load($catlist = '') {
		$cats = explode(",", $catlist);
		
		for ($i = 0; $i < count($cats); $i++) {
			if (@file_exists($this->path."/cache/language/".$this->languagepackid."_".wbb_strtolower($cats[$i]).".php")) {
				include_once($this->path."/cache/language/".$this->languagepackid."_".wbb_strtolower($cats[$i]).".php");
			}
		}
	}
	
	function get($itemname, $params = array()) {  
		if (isset($this->items[$itemname])) {
			$content = $this->items[$itemname];
		}
		else {
			return $itemname;
		}
		
		if (count($params)) {
			return strtr($content, $params);
		}
		else {
			return $content;
		}
	}
	
	function get4eval($itemname) {  
  		return str_replace("\"", "\\\"", $this->get($itemname));      
 	}
	
	function setPath($path) {
		$this->path = $path;
	}
}  
?>